
{-----------------------------------------------------------------------------|
| SPLIT.PAS  -  divides the input stream into one stream sent to a file and  |
|               another sent to standard output.  |
|  |
| Parameters:  p1 - Number of lines sent to the file  |
|              p2 - Name of the file (optional; default = 'part1.dat'  |
|  |
| To be used with DCL Procedure PIPE.COM.                (Author: T.HALL)  |
|  |
|-----------------------------------------------------------------------------}

PROGRAM split (input, output, file_output);

CONST string_length = 984; { Length chosen because of TPU }
      file_name = 'part1.dat';

TYPE  line_type = VARYING [string_length] OF char;

%INCLUDE 'parm.def'      { Allows to get next parameter with proc. NEXT_PARM }

VAR   line, parm, the_file : line_type;
      file_output : FILE OF line_type;
      lines_to_file : integer;

BEGIN {program split}
   next_parm (parm);
   IF parm = '' THEN 
      writeln ('*** SPLIT: Missing Parameter: Lines to sent to the file')
   ELSE
   BEGIN
      readv (parm, lines_to_file);
      next_parm (parm);
      IF parm = '' THEN 
         the_file := file_name
      ELSE 
         the_file := parm;
      open (file_output, the_file);
      rewrite (file_output);
      WHILE NOT eof DO
      BEGIN
         readln (line);
         IF lines_to_file > 0 THEN
         BEGIN
            file_output@ := line;
            put (file_output);
            lines_to_file := pred (lines_to_file);
         END
         ELSE 
            writeln (line);
      END {while};
      close (file_output);
   END {if};
END. {program split}
