
{-----------------------------------------------------------------------------|
| TAIL.PAS  -  writes only the last n lines of input on the output stream  |
|              (default = screen length)  |
|  |
| To be used with DCL Procedure PIPE.COM.                (Author: T.HALL)  |
|  |
|-----------------------------------------------------------------------------}

PROGRAM tail (input, output);
 
CONST string_length = 255;
      standard_tail = 23;

TYPE  line_type = VARYING [string_length] OF char;
      line_buffer = RECORD
                       next : ^line_buffer;
                       buffer_line : line_type;
                    END;

VAR   first_line, last_line, next_line : ^line_buffer := NIL;
      tail_number, lines : integer := 0;
      
%INCLUDE 'parm.def'      { Allows to get next parameter with proc. NEXT_PARM }

VAR   line, parm : line_type;

BEGIN {program tail}
   next_parm (parm);
   IF parm = '' THEN 
      tail_number := standard_tail
   ELSE
   BEGIN
      readv (parm, tail_number);
   END {if};
   WHILE NOT eof DO
   BEGIN
      readln (line);
      lines := succ (lines);
      IF first_line = NIL THEN
      BEGIN
         new (first_line);
         WITH first_line@ DO
         BEGIN
            next := NIL;
            buffer_line := line;
         END {with};
         last_line := first_line;
      END
      ELSE 
      BEGIN
         IF lines > tail_number THEN
         BEGIN
            next_line := first_line;
            first_line := first_line@.next;
            next_line@.next := NIL;
            dispose (next_line);
         END {if};
         new (next_line);
         WITH next_line@ DO
         BEGIN
            next := NIL;
            buffer_line := line;
         END {with};
         last_line@.next := next_line;
         last_line := next_line;
      END {if};
   END {while};
   next_line := first_line;
   WHILE next_line <> NIL DO 
      WITH next_line@ DO
      BEGIN
         writeln (buffer_line);
         next_line := next;
      END {with};   
END. {program tail}
