
{-----------------------------------------------------------------------------|
| This program counts lines and words separated by tabs and blanks in the     |
| the Input Stream.                                                           |
|                                                                             |
| To be used with DCL Procedure PIPE.COM.                (Author: T.HALL)     |
|-----------------------------------------------------------------------------}

PROGRAM wc (input, output);

CONST tab   = chr (9); { Tab stop character }
      blank = ' ';

VAR   line : VARYING [65535] OF char;
      words, lines, characters, i, length : integer := 0;
      ch   : char;

BEGIN {program wc}                              
   WHILE NOT eof DO
   BEGIN
      readln (line);
      lines := succ (lines);
      length := line.length;
      characters := characters + length;
      i := 0;
      WHILE i < length DO
      BEGIN
         i := succ (i);
         ch := line [i];
         IF (ch <> blank) AND (ch <> tab) THEN
         BEGIN
            words := succ (words);
            WHILE (ch <> blank) AND (ch <> tab) DO
            BEGIN
               i := succ (i);
               IF i > line.length THEN
                  ch := blank
               ELSE
                  ch := line [i];
            END {while};
         END {if};
      END {while};
   END {while};
   writeln (tab, 'Lines: ', lines:0, tab, 'Words: ', words:0, tab,
            'Bytes: ', characters:0);
END. {program wc}
