$ vs='f$ver(0) ! WITH.COM  -  Written by framstag@rz.uni-ulm.de, June 1992,
$              !              inspired by T. Hall
$ 
$ if p1 .eqs. "" then inquire p1 "File Specification (type ? for help)"
$ if p1 .eqs. "?"
$ then create sys$output

  WITH [#][?][@]FILESPEC [DO] CMD

This command procedure executes the DCL command CMD once for every file
indicated by FILESPEC.  On each execution, a different filename is substituted
for each occurrence of the string "FILE" in CMD, e.g.

  $ WITH  *.COM DO  DIFF FILE [-]FILE
  $ WITH  #BLU%%.*  EDIT FILE 
  $ WITH  ?*.EXE    DUMP FILE 

- Command DO is optional and may be omitted.
- A # in front of FILESPEC forces WITH to run in quiet mode.
- A ? in front of FILESPEC forces WITH to ask for conformation.
- A @ in front of FILESPEC forces WITH to use the short filename (without path).
- The string FILE will only by substituted if it is in uppercase.
  Therefore, if you don't want the substitution, the CMD-part has to be
  written lowercase in quotes, eg:   WITH *.* "send/file FILE user"
- If you want remaining quotes in the executed command, then use # instead
  of ", they will be substituted, too, eg:   WITH *.* WRITE SYS$OUTPUT #FILE#

$ goto exit
$ endif
$
$ disp = p1
$ p1 = p1-"#"
$ disp = disp .eqs. p1
$
$ conf = p1
$ p1 = p1-"?"
$ conf = conf .nes. p1
$
$ short = p1
$ p1 = p1-"@"
$ short = short .nes. p1
$
$ if p2 .eqs. "DO" then p2 = ""
$ if p2 + p3 .eqs. "" then inquire p2 "Command"
$
$ org_cmd = p2+" "+p3+" "+p4+" "+p5+" "+p6+" "+p7+" "+p8
$
$ quote:
$   pos=f$loc("#",org_cmd) 
$   if pos .lt. f$len(org_cmd)
$     then org_cmd=f$extract(0,pos,org_cmd)+""""+f$extract(pos+1,999,org_cmd)
$     goto quote
$   endif
$
$ if f$loc("FILE",org_cmd) .eq. f$len(org_cmd) then org_cmd = org_cmd+" FILE"
$ filespec = f$parse(p1,";0")
$ set noon
$ on control_y then goto exit
$
$ loop:
$   file=f$search(filespec)
$   if file .eqs. "" then goto exit
$   if short then file = f$parse(file,,,"NAME")+f$parse(file,,,"TYPE")
$   file=f$edit(file,"lowercase")
$   cmd = org_cmd
$   pos = f$locate("FILE",cmd)
$
$   construct:
$     cmd = f$extr(0,pos,cmd) + file + f$extr(pos+4,999,cmd)
$     pos = f$locate("FILE",cmd)
$     if pos .lt. f$length(cmd) then goto construct
$   cmd=f$edit(cmd,"upcase,trim")
$
$   if conf
$     then read/end=exit/prompt="''cmd' [Y] ? " sys$command q
$     q:='f$extr(0,1,q)'
$     if q .eqs. "N" then goto loop
$     if q .eqs. "Q" then goto exit
$     if q .eqs. "A" then conf=0
$   endif
$
$   if disp then write sys$output "$ ",cmd
$   ass sys$command: sys$input /user /nolog
$   'cmd'
$ goto loop
$
$ exit:   vs=f$ver(vs)
